- Main Page
- Classes
- Files
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# sc::SCElementOp Class Reference

Objects of class SCElementOp are used to perform operations on the elements of matrices. More...

`#include <elemop.h>`

Inheritance diagram for sc::SCElementOp:

List of all members.

## Public Member Functions
| SCElementOp (StateIn &s)
virtual int | has_collect ()
| If duplicates of the SCElementOp exist (that is, there is more than one node), then if has_collect returns nonzero then collect is called with a MessageGrp reference after all of the blocks have been processed.
virtual void | defer_collect (int)
virtual void | collect (const Ref< MessageGrp > &)
virtual void | collect (const Ref< SCElementOp > &)
| Multithreaded use of cloneable SCElementOp objects requires that data from cloned objects be collected.
virtual int | has_side_effects ()
| By default this returns nonzero.
virtual bool | threadsafe ()
| Returns true if this SCElementOp is threadsafe.
virtual bool | cloneable ()
| Returns true if this SCElementOp supports the cloneable member.
virtual Ref< SCElementOp > | clone ()
| Returns a clone of this object.
virtual void | process (SCMatrixBlockIter &)=0
| This is the fallback routine to process blocks and is called by process_spec members that are not overridden.
void | process_base (SCMatrixBlock *block)
| Lazy matrix implementors can call this member when the type of block specialization is unknown.
virtual void | process_spec_rect (SCMatrixRectBlock *)
| Matrices should call these members when the type of block is known.
virtual void | process_spec_ltri (SCMatrixLTriBlock *)
virtual void | process_spec_diag (SCMatrixDiagBlock *)
virtual void | process_spec_vsimp (SCVectorSimpleBlock *)
virtual void | process_spec_rectsub (SCMatrixRectSubBlock *)
virtual void | process_spec_ltrisub (SCMatrixLTriSubBlock *)
virtual void | process_spec_diagsub (SCMatrixDiagSubBlock *)
virtual void | process_spec_vsimpsub (SCVectorSimpleSubBlock *)

## Detailed Description

Objects of class SCElementOp are used to perform operations on the elements of matrices.

When the SCElementOp object is given to the element_op member of a matrix, each block the matrix is passed to one of the process, process_base, or process_base members.

## Member Function Documentation

virtual int sc::SCElementOp::has_collect | ( |  | ) | `[virtual]`

If duplicates of the SCElementOp exist (that is, there is more than one node), then if has_collect returns nonzero then collect is called with a MessageGrp reference after all of the blocks have been processed.

The default return value of has_collect is 0 and collect's default action is do nothing. If defer_collect member is called with nonzero, collect will do nothing (this is only used by the blocked matrices).

Reimplemented in sc::SCElementKNorm.

virtual void sc::SCElementOp::collect | ( | const Ref< SCElementOp > & |  | ) | `[virtual]`

Multithreaded use of cloneable SCElementOp objects requires that data from cloned objects be collected.

The default implementation will throw an exception.

Reimplemented in sc::SCElementKNorm.

virtual int sc::SCElementOp::has_side_effects | ( |  | ) | `[virtual]`

By default this returns nonzero.

If the ElementOp specialization will change any elements of the matrix, then this must be overridden to return nonzero.

virtual bool sc::SCElementOp::threadsafe | ( |  | ) | `[virtual]`

Returns true if this SCElementOp is threadsafe.

The default implementation returns false.

virtual bool sc::SCElementOp::cloneable | ( |  | ) | `[virtual]`

Returns true if this SCElementOp supports the cloneable member.

The default implmentation returns false.

virtual Ref<SCElementOp> sc::SCElementOp::clone | ( |  | ) | `[virtual]`

Returns a clone of this object.

This is needed for multithreaded use of SCElementOp objects that are not thread safe. The default implemenation throws an exception.

virtual void sc::SCElementOp::process | ( | SCMatrixBlockIter & |  | ) | `[pure virtual]`

This is the fallback routine to process blocks and is called by process_spec members that are not overridden.

Implemented in sc::SCElementKNorm.

void sc::SCElementOp::process_base | ( | SCMatrixBlock * | block | ) |

Lazy matrix implementors can call this member when the type of block specialization is unknown.

However, this will attempt to dynamic_cast block to a block specialization and will thus be less efficient.

virtual void sc::SCElementOp::process_spec_rect | ( | SCMatrixRectBlock * |  | ) | `[virtual]`

Matrices should call these members when the type of block is known.

ElementOp specializations should override these when efficiency is important, since these give the most efficient access to the elements of the block.

The documentation for this class was generated from the following file:

- elemop.h